/* 
FileIcon Plugin
January 25, 2000
doug.holton@vanderbilt.edu


This source uses these sources:
Find_Icon by James W. Walker
http://www.jwwalker.com/pages/codes.html
MoreFiles
http://developer.apple.com/samplecode/Sample_Code/Files/MoreFiles.htm
Thomas Tempelmann's Plugin Starter
http://www.tempel.org/rb/


*/

#include <string.h>
#include "rb_plugin.h"
#include <Icons.h>
#include "Find_icon.h"

Find_icon_UPP	gFindIcon = NULL;
Handle			findIconProc;


static REALpicture FileIcon (REALfolderItem f, int size, int depth, int transform)
{
	FSSpec					spec;
	OSErr					err;
	Handle					suite;
	MetaSelectorValue		selector;
	Boolean					ok;
	Rect					r;
	GWorldPtr 				world;
    GWorldPtr				oldWorld;
    GDHandle				oldDev;

    
	if (findIconProc == NULL)
	{
		//SysBeep(30);
		return nil;
	}
	
	ok=REALFSSpecFromFolderItem(&spec, f);
	if(ok != true)
	{
		//SysBeep(30);
        return nil;
    }

	selector=kSelectorAllAvailableData;
	//another way to speed things up would be to use a more narrow metaselector
	//such as kSelectorLargeThenSmall;

	err=CallFindIcon( gFindIcon, &spec, nil, selector, &suite );
	
	if (err == noErr)
	{

		SetRect (&r, 0, 0, size, size);
	    GetGWorld(&oldWorld, &oldDev);
	   	NewGWorld (&world, depth, &r, nil, nil, 0);
		SetGWorld(world,nil);
		EraseRect(&r);	
	
		PlotIconSuite( &r, kAlignNone,transform,suite);
		DisposeIconSuite( suite, true );	
	    SetGWorld(oldWorld, oldDev);

		return REALBuildPictureFromGWorld (world, true);	

	} else {
		return nil;
	}

}



REALexport pluginExports[] = {
	{ nil, FileIcon }
};

short pluginExportCode = sizeof(pluginExports) / sizeof(REALexport);

REALmethodDefinition methods[] = {
	{0,	"FileIcon(f as folderitem, size as Integer, depth as Integer, transform as Integer) as Picture"}
};

void PluginEntry (void)
{

	if (gFindIcon==NULL)
	{
		findIconProc = GetResource( 'PROC', 128 );	
		if (findIconProc != NULL)
		{
			HLock( findIconProc );
			gFindIcon = (Find_icon_UPP) *findIconProc;
		}	
	}
	for (int i = 0; i < pluginExportCode; ++i) {
		REALRegisterMethod (&methods[i]);
	}
}

