/****************************************************************************
	Engine plattform SDK 1.0d1
	
	Created 20/11/1999
	 Einhugur Software
	
	Checklist
	
	1. Change the GUID
	2. Write a info string
	2. Write your code
	3. Compile
	4. Put icon on your plugin
	5. Deploy your plugin

****************************************************************************/

#include <MixedMode.h>
#include <String.h>

#ifndef powerc
	#include <A4Stuff.h>
#endif

#define PLATFORM_VERSION 1

// You must provide your own unigue GUID for the engine

// To do: Create your own GUID with GUID creator (can use UtilsLib to create a GUID (with - - marks))
//        and replace the guid here bellow with yours, do not remove the "{ }\n"
#define ENGINE_GUID "{A4B3C452-9F5F-11D3-B251-0005081B0E27}\n"

// To do: Provide a InfoString (careful not to remove the \n
#define INFO_STRING "MyCool Encryption engine\n"


// Dont do anything here
// ****************************************************************************
struct EngineEntry
{
	void* Reserved;
	void* CreateKey;
	void* EncryptData;
	void* FinishEncrypting;
	void* DecryptData;
	void* FinalDecryptData;
	void* DisposeKey;
	long iOffset;
	char* key;       // As char* is a general pointer then you can store
	                 // what ever you need in it, for example then the Blowfish
	                 // algorithm stores a BlowKey class here
	long iKeySize;
	
	char* AlgorithmGUID;  // This is 38 character preallocated buffer to transfer the GUID
	char* InfoString;	  // Unlocated buffer, which the plugin plattform will dealocate
	
	int   VersionSupport; 
};
// ****************************************************************************


char* EncryptData(EngineEntry* es,char* Data,long datalength,long & outLength)
{
	long Cryptfactor;
	char* outData = (char*) NewPtr(datalength+1); // The Engine plattform will dispose this one
												  // (relax the engine plattform takes care of lot of things)
	memcpy(outData,Data,datalength);
	
	outLength = datalength;
	
	//  To do: Encrypt the buffer (outData) that you get, the offset of the buffer that you
	//         are getting you can read from iOffset	
	

	
	return outData;
}

char* DecryptData(EngineEntry* es,char* Data,long datalength,long & outLength)
{
	long Cryptfactor;
	char* outData = (char*) NewPtr(datalength+1); // The Engine plattform will dispose this one
												  // (relax the engine plattform takes care of lot of things)
	memcpy(outData,Data,datalength);
	outLength = datalength;
	
	//  To do: Decrypt the buffer (outData) that you get, the offset of the buffer that you
	//         are getting you can read from iOffset
	
	
	return outData;
}

char* FinalDecryptData(EngineEntry* es,char* Data,long datalength,long & outLength)
{
	//  To do: Now this is a vierd function, it represents the last Cycle of the
	//         decryption process, usually it just calls DecryptData, but some algoritms may
	//         have to decrypt differently in the last cycle
	
	return DecryptData(es,Data,datalength,outLength);
}


void CreateKey(EngineEntry* es,char* key,long keylen)
{
	// key is a "safe" char* which will not be dealocated until the class is terminated

	// To do: Create your Key and store in m_EngineData->key (your key can be a class,struct or char*)
}

void DisposeKey(EngineEntry* es)
{
	//  To do: Dispose your key if needed
	//  (if you only did m_EngineData->key = key in the CreateKey then dont dispose
	//   as you have not created anything your self)
}

char* FinishEncrypting(EngineEntry* es,long & outLength)
{
	//  To do: Great !! we have another wierd one here
	//  This function is used to finalize the Encryption process and is
	//  usually left empty (some algoritms like blowfish may use this
	//  to adjust the checksum by adding a few bytes here)
	
	// Anthing you return from this function the Engine plattform will dispose
	// (the retunr buffer you should create with NewPtr) And dont forget to adjust the outLength 
	// if you use this function.
	
	return nil;
}

// Here bellow you should not do anything
// ****************************************************************************
ProcInfoType __procinfo = kThinkCStackBased
		 | STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(EngineEntry*)));

void main(EngineEntry* es)
{
	#ifndef powerc
		long oldA4 = SetCurrentA4();
	#endif
	es->CreateKey = CreateKey;
	es->EncryptData=EncryptData;
	es->DecryptData=DecryptData;
	es->FinalDecryptData=FinalDecryptData;
	es->DisposeKey=DisposeKey;
	es->FinishEncrypting=FinishEncrypting;
	
	es->VersionSupport=PLATFORM_VERSION;
	es->InfoString = NewPtr(strlen(INFO_STRING)+1);
	strcpy(es->InfoString,INFO_STRING);
	
	strcpy(es->AlgorithmGUID,ENGINE_GUID);
	#ifndef powerc
		SetA4(oldA4);
	#endif
}
// ****************************************************************************