/*
 * QuitHandler.cp
 *
 * Shows how to cleanup when your app unexpectedly quits
 *
 * By Thomas Tempelmann (macdev@tempel.org), 4 Jan 2001
 */

#if not TARGET_OS_MAC
	#error This file (QuitHandler.cp) can currently only be used for MacOS targets!
#endif

#if not TARGET_CARBON

#include <SetupA4.h>
#include <Traps.h>
#include <OSUtils.h>
#include <Processes.h>
#include "QuitHandler.h"

#if not TARGET_CPU_68K
#define far
#endif

far static UniversalProcPtr gOldExitToShell = nil, gNewExitToShell;
far static QuitProcPtr gHandleQuit;

static void deInstallQuitHandler ()
// uninstalls the ExitToShell patch
{
	if (gOldExitToShell) SetToolTrapAddress (gOldExitToShell, _ExitToShell);
	gOldExitToShell = nil;
}

static pascal void quitHandler (void)
// gets called when ExitToShell() is executed
{
	EnterCallback();
	deInstallQuitHandler ();
	gHandleQuit ();
	ExitCallback();
	ExitToShell ();
}

void InstallQuitHandler (QuitProcPtr callAtQuit)
// installs the ExitToShell patch
{
	PrepareCallback ();
	gHandleQuit = callAtQuit;
	gNewExitToShell = NewRoutineDescriptor ((ProcPtr)quitHandler, kPascalStackBased, GetCurrentISA());
	gOldExitToShell = NGetTrapAddress (_ExitToShell, 1);
	SetToolTrapAddress (gNewExitToShell, _ExitToShell);
}

#endif

// EOF
